Index: ChangeLog
===================================================================
--- ChangeLog	(revision 1390)
+++ ChangeLog	(working copy)
@@ -1,6 +1,18 @@
+2016-05-08  Milan Kupcevic <milan@debian.org>
+
+	* avrdude.conf.in (ATmega48, ATmega88, ATmega168, ATmega328)
+	(ATmega32U4, ATmega640, ATmega1280, ATmega1281, ATmega2560)
+	(ATmega2561, ATmega8, ATtiny13, ATmega64, ATmega128, ATmega16)
+	(AT90CAN32, AT90CAN64, AT90CAN128, ATmega324, ATmega644)
+	(ATmega1284, ATmega161, ATmega162, ATmega163, ATmega169, ATmega32)
+	(ATmega329, ATmega649, ATmega8515, ATmega8535, ATtiny2313, ATtiny4313)
+	(AT90PWM2, AT90USB646, AT90USB1286, AT90USB162, AT90USB82, ATmega32U2)
+	(ATmega16U2, ATmega8U2, ATmega325, ATmega645, ATtiny1634): Remove
+	lock byte read mask (bug#46759).
+
 2016-04-20  Joerg Wunsch <j.gnu@uriah.heep.sax.de>
 
 	* configure.ac (libftdi1): Rather than hardcoding the library
 	providing the libusb-1.0 API, use the result from the previous
 	probe.  This helps detecting libftdi1 on FreeBSD where the
 	libusb-1.0 API is provided by the system's libusb.
Index: NEWS
===================================================================
--- NEWS	(revision 1390)
+++ NEWS	(working copy)
@@ -9,12 +9,13 @@
 
   * Major changes compared to the previous version:
 
     - libhidapi support (part of patch #8717)
     - use libhidapi as (optional) transport for CMSIS-DAP compliant
       debuggers (JTAGICE3 with firmware 3+, AtmelICE, EDBG, mEDBG)
+    - unused lock byte bits are not masked on read anymore
 
   * New devices supported:
 
   * New programmers supported:
 
   * Bugfixes:
Index: avrdude.conf.in
===================================================================
--- avrdude.conf.in	(revision 1390)
+++ avrdude.conf.in	(working copy)
@@ -1819,13 +1819,13 @@
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
 
 	read            = "0  1  0  1   1  0  0  0    0 0 0 0  0 0 0 0",
-                          "x  x  x  x   x  x  x  x    x x o o  o o o o";
+                          "x  x  x  x   x  x  x  x    o o o o  o o o o";
 
         write           = "1  0  1  0   1  1  0  0    1 1 1 x  x x x x",
                           "x  x  x  x   x  x  x  x    1 1 i i  i i i i";
     ;
 
     memory "calibration"
@@ -3326,13 +3326,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -3509,13 +3509,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -3701,13 +3701,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -3893,13 +3893,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -4085,13 +4085,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -4242,13 +4242,13 @@
 	readsize	= 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -4444,13 +4444,13 @@
 	readsize	= 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -4652,13 +4652,13 @@
 	readsize	= 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -4860,13 +4860,13 @@
 	readsize	= 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -5054,13 +5054,13 @@
 	readsize	= 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -5287,13 +5287,13 @@
     memory "lock"
         size            = 1;
         min_write_delay = 16000;
         max_write_delay = 16000;
 
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         ;
 
     memory "signature"
@@ -5449,13 +5449,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  0 x x x   x x o o  o o o o";
+                          "x x x x  0 x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "signature"
@@ -5631,13 +5631,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "signature"
@@ -5816,13 +5816,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "signature"
@@ -6042,13 +6042,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "signature"
@@ -6233,13 +6233,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "signature"
@@ -6379,13 +6379,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
     memory "signature"
         size            = 3;
@@ -6532,13 +6532,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -6689,13 +6689,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -6849,13 +6849,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 2000;
         max_write_delay = 2000;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -7827,13 +7827,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -8039,13 +8039,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -8253,13 +8253,13 @@
     
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0",
-                          "x x x x x x x x x x o o o o o o";
+                          "x x x x x x x x o o o o o o o o";
         
         write           = "1 0 1 0 1 1 0 0 1 1 1 x x x x x",
                           "x x x x x x x x 1 1 i i i i i i";
         ;
     
     memory "calibration"
@@ -8465,13 +8465,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
       ;
 
     memory "calibration"
@@ -8655,13 +8655,13 @@
 
     memory "lock"
 	size = 1;
 	min_write_delay = 4500;
 	max_write_delay = 4500;
 	read = "0 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0",
-	       "x x x x x x x x x x o o o o o o";
+	       "x x x x x x x x o o o o o o o o";
 
 	write = "1 0 1 0 1 1 0 0 1 1 1 x x x x x",
 	      	"x x x x x x x x 1 1 i i i i i i";
     ;
 
     memory "calibration"
@@ -8844,13 +8844,13 @@
        ;
      memory "lock"
          size            = 1;
          write           = "1 0 1 0  1 1 0 0  1 1 1 x  x x x x",
                            "x x x x  x x x x  1 1 i i  i i i i";
          read           = "0 1 0 1  1 0 0 0  0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x  x x o o  o o o o";
+                          "x x x x  x x x x  o o o o  o o o o";
         min_write_delay = 9000;
         max_write_delay = 9000;
        ;
 
      memory "lfuse"
          size            = 1;
@@ -9030,13 +9030,13 @@
        ;
      memory "lock"
          size            = 1;
          write           = "1 0 1 0  1 1 0 0  1 1 1 x  x x x x",
                            "x x x x  x x x x  1 1 i i  i i i i";
          read           = "0 1 0 1  1 0 0 0  0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x  x x o o  o o o o";
+                          "x x x x  x x x x  o o o o  o o o o";
         min_write_delay = 9000;
         max_write_delay = 9000;
        ;
 
      memory "lfuse"
          size            = 1;
@@ -9212,13 +9212,13 @@
      memory "lock"
          size            = 1;
          write           = "1 0 1 0  1 1 0 0  1 1 1 x  x x x x",
                            "x x x x  x x x x  1 1 i i  i i i i";
 
          read            = "0 1 0 1  1 0 0 0  0 0 0 0  0 0 0 0",
-                           "x x x x  x x x x  x x o o  o o o o";
+                           "x x x x  x x x x  o o o o  o o o o";
         min_write_delay = 9000;
         max_write_delay = 9000;
        ;
 
      memory "lfuse"
          size            = 1;
@@ -10079,13 +10079,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -10269,13 +10269,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -10477,13 +10477,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -11648,13 +11648,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -11839,13 +11839,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12043,13 +12043,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12240,13 +12240,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12427,13 +12427,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12616,13 +12616,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12804,13 +12804,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -12992,13 +12992,13 @@
         max_write_delay = 9000;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 x  x x x x",
                           "x x x x  x x x x   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -13146,13 +13146,13 @@
         readsize        = 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 0  0 0 0 0",
                           "0 0 0 0  0 0 0 0   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -13337,13 +13337,13 @@
         readsize        = 256;
       ;
 
     memory "lock"
         size            = 1;
         read            = "0 1 0 1  1 0 0 0   0 0 0 0  0 0 0 0",
-                          "x x x x  x x x x   x x o o  o o o o";
+                          "x x x x  x x x x   o o o o  o o o o";
 
         write           = "1 0 1 0  1 1 0 0   1 1 1 0  0 0 0 0",
                           "0 0 0 0  0 0 0 0   1 1 i i  i i i i";
         min_write_delay = 9000;
         max_write_delay = 9000;
       ;
@@ -14761,13 +14761,13 @@
 
     memory "lock"
         size            = 1;
         min_write_delay = 4500;
         max_write_delay = 4500;
         read            = "0 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0",
-                          "x x x x x x x x x x x x x x o o";
+                          "x x x x x x x x o o o o o o o o";
 
         write           = "1 0 1 0 1 1 0 0 1 1 1 x x x x x",
                           "x x x x x x x x 1 1 1 1 1 1 i i";
         ;
 
     memory "calibration"